import GitlabRepository from '../../shared/types/Gitlab/GitlabRepository';
import { CommitSchema } from '@gitbeaker/rest';
import User             from './User';
import Assignment       from './Assignment';
import SonarProjectCreation from '../../shared/types/Sonar/SonarProjectCreation';


interface Exercise {
    id: string;
    assignmentName: string;
    name: string;
    gitlabId: number;
    gitlabLink: string;
    gitlabCreationInfo: GitlabRepository;
    gitlabLastInfo: GitlabRepository;
    gitlabLastInfoDate: string;

    sonarKey: string;
    sonarCreationInfo: SonarProjectCreation;

    members: Array<User> | undefined;
    assignment: Assignment | undefined;

    isCorrection: boolean;
    correctionCommit: CommitSchema | undefined;
}


export default Exercise;